import arcade
import logging


class Bot(arcade.Sprite):
    """
    Bot sprite
    """
    def __init__(self, start, grid, scale=0.75):
        self.sprite = ":resources:images/space_shooter/playerShip1_green.png"

        self.grid = grid
        self.pos = list(start)

        super().__init__(self.sprite, scale, hit_box_algorithm="None")
        self.set_pos()
        self.angle = 270

    def set_pos(self):
        for tile in self.grid.tiles:
            if tile.pos == tuple(self.pos):
                self.position = tile.position
                logging.debug(f"Move bot to {self.pos} - {self.position}")
                break

    def left(self):
        self.angle += 90
        if self.angle >= 360:
            self.angle -=360

    def right(self):
        self.angle -= 90
        if self.angle < 0:
            self.angle += 360

    def forward(self):
        match self.angle:
            case 0:
                if self.pos[1] < self.grid.column - 1:
                    self.pos[1] += 1
            case 90:
                if self.pos[0] > 0:
                    self.pos[0] -= 1
            case 180:
                if self.pos[1] > 0:
                    self.pos[1] -= 1
            case 270:
                if self.pos[0] < self.grid.row - 1:
                    self.pos[0] += 1

        self.set_pos()
